#ifndef TM1637_H
#define	TM1637_H
//------------------------------------------------------------------------------
#include "../../assets/twoWire/twoWire.h"
#include "TM1637_prototypes.h"
//Common Anode             0,    1,    2,    3,    4,    5,    6,    7,    8,   9
const char digits[] = { 0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F };
//------------------------------------------------------------------------------
void TM1637_init(char level)
{
    twoWire_init();    
    TM1637_setBrightness(level); //Valid brightness values: 0 - 8. 0 = display off.
}
//------------------------------------------------------------------------------
void TM1637_display(signed int number)
{    
    TM1637_command(DISPLAY_MODE);    
    TM1637_write(toString(number));
}
//------------------------------------------------------------------------------
void TM1637_setBrightness(char level)
{    
    TM1637_command(DISPLAY_CTRL + level); // Valid brightness values: 0 - 8. 0 = display off.
}
//------------------------------------------------------------------------------
void TM1637_write(char text[])
{
    TM1637_initSend(DISPLAY_REG0);
    
    while(*text)
    {        
        char digit = getDigit(*text++);
        
        twoWire_write(digit);
        twoWire_ack();
    }
    
    twoWire_stop();
}
//------------------------------------------------------------------------------
void TM1637_command(char command)
{
    TM1637_initSend(command);
    twoWire_stop();
}
//------------------------------------------------------------------------------
void TM1637_initSend(char command)
{
    twoWire_start();
    twoWire_write(command);
    twoWire_ack();
}
//------------------------------------------------------------------------------
char getDigit(char asciiChar)
{
    char digit = 0;
    
    if(asciiChar >= '0' && asciiChar <= '9')
    {
        char i = asciiChar - '0'; //Get index 0 - 9
        digit = digits[i];
    }
    else
        if(asciiChar == '-')
        {
            digit = 0x40;  //0x40 - minus symbol
        }
        else
            if(asciiChar == ' ')
            {
                digit = 0x00; //0x00 - blank. used for leading zero suppression
            }
    
    return digit;
}
//------------------------------------------------------------------------------
char* toString(signed int number)
{
    char strNum[8];
    sprintf(strNum,"%4i",number);
    
    return strNum;
}
//------------------------------------------------------------------------------
#endif	/* TM1637_H */